
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Chat_threadsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_threads = await db.chat_threads.create(
            {
                id: data.id || undefined,
        
        thread_title: data.thread_title
        ||
        null
            ,
            
        thread_type: data.thread_type
        ||
        null
            ,
            
        last_message_at: data.last_message_at
        ||
        null
            ,
            
        is_pinned: data.is_pinned
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await chat_threads.setWorkspace( data.workspace || null, {
            transaction,
        });
        
        await chat_threads.setStarted_by( data.started_by || null, {
            transaction,
        });
        
        await chat_threads.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return chat_threads;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const chat_threadsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                thread_title: item.thread_title
            ||
            null
            ,
            
                thread_type: item.thread_type
            ||
            null
            ,
            
                last_message_at: item.last_message_at
            ||
            null
            ,
            
                is_pinned: item.is_pinned
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const chat_threads = await db.chat_threads.bulkCreate(chat_threadsData, { transaction });

        // For each item created, replace relation files
        

        return chat_threads;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const chat_threads = await db.chat_threads.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.thread_title !== undefined) updatePayload.thread_title = data.thread_title;
        
        
        if (data.thread_type !== undefined) updatePayload.thread_type = data.thread_type;
        
        
        if (data.last_message_at !== undefined) updatePayload.last_message_at = data.last_message_at;
        
        
        if (data.is_pinned !== undefined) updatePayload.is_pinned = data.is_pinned;
        
        
        updatePayload.updatedById = currentUser.id;

        await chat_threads.update(updatePayload, {transaction});

        
        
        if (data.workspace !== undefined) {
            await chat_threads.setWorkspace(
              
              data.workspace,
              
              { transaction }
            );
        }
        
        if (data.started_by !== undefined) {
            await chat_threads.setStarted_by(
              
              data.started_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await chat_threads.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return chat_threads;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const chat_threads = await db.chat_threads.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of chat_threads) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of chat_threads) {
                await record.destroy({transaction});
            }
        });


        return chat_threads;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const chat_threads = await db.chat_threads.findByPk(id, options);

        await chat_threads.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await chat_threads.destroy({
            transaction
        });

        return chat_threads;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const chat_threads = await db.chat_threads.findOne(
            { where },
            { transaction },
        );

        if (!chat_threads) {
            return chat_threads;
        }

        const output = chat_threads.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.chat_messages_thread = await chat_threads.getChat_messages_thread({
            transaction
        });
        
        
        
        
        
        
        output.workspace = await chat_threads.getWorkspace({
            transaction
        });
        
        
        output.started_by = await chat_threads.getStarted_by({
            transaction
        });
        
        
        output.organizations = await chat_threads.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.workspaces,
        as: 'workspace',
        
        where: filter.workspace ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workspace.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workspace.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'started_by',
        
        where: filter.started_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.started_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.started_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.thread_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'chat_threads',
                        'thread_title',
                        filter.thread_title,
                    ),
                };
            }
            

            
            

            
            if (filter.last_message_atRange) {
                const [start, end] = filter.last_message_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_message_at: {
                    ...where.last_message_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.thread_type) {
                where = {
                    ...where,
                thread_type: filter.thread_type,
            };
            }
            
            if (filter.is_pinned) {
                where = {
                    ...where,
                is_pinned: filter.is_pinned,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.chat_threads.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'chat_threads',
                        'thread_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.chat_threads.findAll({
            attributes: [ 'id', 'thread_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['thread_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.thread_title,
        }));
    }

    
};

